searchNodes=[{"doc":"A LiveComponent for passwordless authentication via WebAuthn.","ref":"WebAuthnComponents.html","title":"WebAuthnComponents","type":"module"},{"doc":"Handlers for server and client events. Server-Side Events The following events are triggered by the rendered form: &quot;update_changeset&quot; - Form data has changed. &quot;start_registration&quot; - The user wants to create a new account. &quot;start_authentication&quot; - The user wants to sign in as an existing user. While the update_changeset event handler extracts data from the params argument, start_registration and start_authentication ignore the params argument, pulling state from the socket assigns instead. Client-Side Events WebAuthnComponents uses a Javascript (JS) hook to interact with the client-side WebAuthn API. The following events are triggered by the WebAuthn JS hook: &quot;webauthn_supported&quot; - The JS hook as reported whether webauthn is supported. &quot;user_token&quot; - A token stored in the client's sessionStorage . &quot;register_attestation&quot; - A WebAuthn registration attestation created by the client. &quot;authenticate_attestation&quot; - A WebAuthn authentication attestation created by the client.","ref":"WebAuthnComponents.html#handle_event/3","title":"WebAuthnComponents.handle_event/3","type":"function"},{"doc":"Ensure required assigns are present, falling back to default values where necessary.","ref":"WebAuthnComponents.html#mount/1","title":"WebAuthnComponents.mount/1","type":"function"},{"doc":"Render the WebAuthn form.","ref":"WebAuthnComponents.html#render/1","title":"WebAuthnComponents.render/1","type":"function"},{"doc":"update/2 is used here to catch the found_user assign once it's placed by the parent LiveView.","ref":"WebAuthnComponents.html#update/2","title":"WebAuthnComponents.update/2","type":"function"},{"doc":"Component which renders a basic HTML button.","ref":"WebAuthnComponents.Button.html","title":"WebAuthnComponents.Button","type":"module"},{"doc":"Attributes label ( :string ) - Text to be rendered inside the button, visible to the user. Defaults to &quot;Sign in a Passkey&quot; . class ( :string ) - Defaults to &quot;px-4 p-2 bg-blue-500 text-white rounded shadow-md&quot; . rest ( :global )","ref":"WebAuthnComponents.Button.html#render/1","title":"WebAuthnComponents.Button.render/1","type":"function"},{"doc":"Custom type for WebAuthn cose keys.","ref":"WebAuthnComponents.CoseKey.html","title":"WebAuthnComponents.CoseKey","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"WebAuthnComponents.CoseKey.html#cast/1","title":"WebAuthnComponents.CoseKey.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"WebAuthnComponents.CoseKey.html#dump/1","title":"WebAuthnComponents.CoseKey.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"WebAuthnComponents.CoseKey.html#embed_as/1","title":"WebAuthnComponents.CoseKey.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"WebAuthnComponents.CoseKey.html#equal?/2","title":"WebAuthnComponents.CoseKey.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"WebAuthnComponents.CoseKey.html#load/1","title":"WebAuthnComponents.CoseKey.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"WebAuthnComponents.CoseKey.html#type/0","title":"WebAuthnComponents.CoseKey.type/0","type":"function"},{"doc":"LiveComponent for interacting with Passkeys. Caution This component should be considered in alpha status, with changes to the API, bugs, and incomplete documentation to be expected. It is not advisable to use this component in a production environment at this time. Overview &quot;Passkey&quot; is an end-user-friendly moniker for the WebAuthentication API, aka WebAuthn, where credentials may be used across devices through a cloud synchronization mechanism. Support for Passkeys requires integration with a user's operating system, browser, and device. It also requires Javascript to be enabled in the browser since WebAuthn is a browser API, where credential creation and verification is performed. Cloud synchronization is currently handled by the user's operating system - Keychain for MacOS users and Google Password Manager for Android users. Third party services such as 1Password have also announced plans for Passkey support in upcoming releases. Terms Registration : The process of creating a new credential to be used for a new account in your application. Authentication : The process of using an existing credential to access an existing account in your application. A New Paradigm With Passkeys, it may be challenging (pardon the pun) to understand how registration and authentication are performed. The model differs from traditional username + password authentication in significant ways. This implementation of Passkeys takes advantage of userless or loginless authentication, where the user need not provide a username, email, password, or other data required for traditional registration. Instead, a UUID is provided to to the WebAuthn API along with other challenge data. Customization The registration and authentications processes are handled by this LiveComponent, which includes both a Register and Authenticate button. Communication Throughout the registration and authentication process, some messages must be passed to the parent LiveView. In the parent LiveView, use handle_info/2 to accept the following messages: {:passkeys_supported, boolean} : If false, an error should be displayed to the user. {:token_exists, token: token} : Reports an existing session token. The parent application may decide whether to redirect to another view, clear the token, or render an error. {:token_stored, token: token} : Reports a token was successfully stored in the user's browser. The user should be redirected to another view at this point. For new users, it is recommended to proceed with profile setup since email and other details are not collected during registration. {:token_cleared} : Reports that a token was successfully cleared. A message may be displayed to the user if it makes sense to do so. {:registration_failure, message: message} : Reports an error which should be displayed to the user. The parent application may display human-friendly verbiage instead, logging the error for internal debugging. {:find_credentials, user_handle: user_handle} : Reports a user_handle is requesting authentication. The parent application must return a matching user, if one exists, in order to proceed with authentication. {:authentication_successful, key_id: raw_id, auth_data: auth_data} : Reports the user was successfully authenticated by the WebAuthn API. The parent LiveView should create a new session token and pass it back to the component for persistence in the user's browser. {:authentication_failure, message: message} : Reports the provided user could not be authenticated, with a message that may be displayed or paraphrased for the user. {:error, payload} : Reports an error to the parent LiveView to be displayed or paraphrased for the user. Errors are reported and should typically be rendered to the user via flash messages and/or logged in the application's error tracking system for analysis. The component passes these messages to the LiveView to allow complete control over visibility, appearance, and wording of errors. Tokens TODO: Document token expectations and best practices.","ref":"WebAuthnComponents.PasskeyComponent.html","title":"WebAuthnComponents.PasskeyComponent","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"WebAuthnComponents.PasskeyComponent.html#handle_event/3","title":"WebAuthnComponents.PasskeyComponent.handle_event/3","type":"function"},{"doc":"","ref":"WebAuthnComponents.PasskeyComponent.html#icon_info_circle/1","title":"WebAuthnComponents.PasskeyComponent.icon_info_circle/1","type":"function"},{"doc":"","ref":"WebAuthnComponents.PasskeyComponent.html#icon_key/1","title":"WebAuthnComponents.PasskeyComponent.icon_key/1","type":"function"},{"doc":"Mounts the component with default assigns. Configurable Assigns The following assigns may be passed to the component from your LiveView: @app : Required - The name of you application. May be a string or atom. @button_class : Styles for buttons in the component. @div_class : Styles for the &lt;div&gt; container for the buttons. @support_error_class : Styles for the &lt;aside&gt; displayed when Passkeys are not supported. @timeout : Milliseconds until registration and authentication prompts expire. This value is passed to the WebAuthn API. Internal Assigns Other assigns are set internally, but listed here for transparency: @passkeys_supported : A boolean set to true when the Passkey LiveView hook detects WebAuthn support. Otherwise, it is set to false . The initial value is nil . See caniuse.com for browser support details.","ref":"WebAuthnComponents.PasskeyComponent.html#mount/1","title":"WebAuthnComponents.PasskeyComponent.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"WebAuthnComponents.PasskeyComponent.html#render/1","title":"WebAuthnComponents.PasskeyComponent.render/1","type":"function"},{"doc":"Stores or clears a session token. When a :token assign is received, this function will either clear or store the user's token. Assign token: :clear to remove a user's token. Assign a binary token (typically a base64-encoded crypto hash) to persist a user's token to the browser's sessionStorage . Invalid token assigns will be logged and the socket will be returned unchanged.","ref":"WebAuthnComponents.PasskeyComponent.html#update/2","title":"WebAuthnComponents.PasskeyComponent.update/2","type":"function"},{"doc":"A drop-in LiveComponent for password-less authentication. 🚨 Status 🚨 This package is a work in progress , and it is in early alpha status. Feel free to experiment with this package and contribute feedback through GitHub discussions . Please do not use WebAuthnComponents in a production environment until it has completed beta testing.","ref":"readme.html","title":"WebAuthnComponents","type":"extras"},{"doc":"View the planned work for this repo in the public WebAuthnComponents v1 project on GitHub.","ref":"readme.html#roadmap","title":"WebAuthnComponents - Roadmap","type":"extras"},{"doc":"During the beta phase, generators will be added to streamline initial setup, including running migrations, generating related modules, etc. Steps marked (TODO) need additional documentation, and some may be streamlined by Mix tasks during the beta phase. Add Mix dependency Add WebAuthn hook to app.js Run Mix task to create user_keys schema &amp; migration mix phx.gen.context --binary-id Authentication UserKey user_keys key_id:binary label last_used:utc_datetime public_key:binary user_id:references:users Update UserKey schema (TODO) Add default value to the label field Update the public_key field to use WebAuthnComponents.CoseKey as its type Add new_changeset/2 &amp; update_changeset/2 (TODO) Run Mix task to create user_tokens schema &amp; migration mix phx.gen.context --binary-id Authentication UserToken user_tokens user_id:references:users token:binary context Update UserToken schema Update the context field to use Ecto.Enum as its type with values: [:session, :device_code] and default: :session Replace user_id field with belongs_to User association Add foreign_key_constraint :user_id Add token helper functions (TODO) Update User and/or relevant schemas to include keys association (TODO) Run Mix task to add component config (TODO) Installation Add webauthn_components to your list of dependencies in mix.exs : def deps do [ { :webauthn_components , &quot;~&gt; 0.1.0&quot; } ] end Usage See WebAuthnComponents for detailed usage instructions.","ref":"readme.html#quick-start","title":"WebAuthnComponents - Quick Start","type":"extras"},{"doc":"The Web Authentication API is an extension of the Credential Management API that enables strong authentication with public key cryptography, enabling passwordless authentication and/or secure second-factor authentication without SMS texts. https://developer.mozilla.org/en-US/docs/Web/API/Web_Authentication_API A passkey is a FIDO login credential, tied to an origin (website or application) and a physical device. Passkeys allow users to authenticate without having to enter a username, password, or provide any additional authentication factor. This technology aims to replace passwords as the primary authentication mechanism. https://developers.google.com/identity/fido Passkeys are essentially a standard to sync WebAuthn credentials with cloud platforms like iCloud Keychain , Android , 1Password , with more to come. Benefits There are many benefits to users and application maintainers when passwords are decommissioned. Eliminates password reuse by users. Mitigates credential stuffing attacks by hackers. Eliminates phishing attacks by hackers. For users on a device with Passkey support, WebAuthn credentials may be stored in the cloud. This allows the user to authenticate from other cloud-connected devices without registering each device individually. Known Issues While WebAuthn provides an API for improved authentication security, there are a few limitations to consider before adopting this component. As of 2022, Passkeys are not universally supported. If a user registers or authenticates on a device without Passkey support, the generated key pair will not be synced, and each device must be registered in order to access an account. Cloud-synced credentials are only accessible to devices authenticated to the cloud account. For example, a credential saved to iCloud Keychain will not be synced automatically to Android's credential manager.","ref":"readme.html#webauthn-passkeys","title":"WebAuthnComponents - WebAuthn &amp; Passkeys","type":"extras"},{"doc":"The WebAuthn API has broad support across the most common modern browsers. https://caniuse.com/?search=webauthn","ref":"readme.html#browser-support","title":"WebAuthnComponents - Browser Support","type":"extras"},{"doc":"https://webauthn.guide/ https://developer.mozilla.org/en-US/docs/Web/API/Web_Authentication_API https://fidoalliance.org/fido2-2/fido2-web-authentication-webauthn/ https://www.w3.org/TR/webauthn-2/","ref":"readme.html#additional-resources","title":"WebAuthnComponents - Additional Resources","type":"extras"}]